/*
 * File:   LCDLib.c
 * Author: M.Urushidani
 *
 * Created on 2019/04/15, 13:01
 */

#include <xc.h>
#include "LCDLib.h"

void stbo(int flag){
         if(flag == 0){
        RS = 0 ;
    } else {
        RS = 1 ;
    }
    STB = 1 ;
    __delay_us(8);
    STB = 0 ;
}
void delay_ms(unsigned int count) {
    int dly ;
        for(dly=1;dly<=count;dly++){
            __delay_ms(1) ;
   }
}

void lcd_init(void){
    delay_ms(70) ;
    send(0b00000011) ;
    delay_ms(50) ;
    send(0b00000011) ;
    delay_ms(10) ;
    send(0b00000011) ;
    __delay_us(50);
    send(0b0010) ;
    __delay_us(50);
    lcd_cmd(0b00101000) ;
    lcd_cmd(0b1100) ;
    lcd_cmd(0b0110) ;
    lcd_cmd(2) ;
    delay_ms(4) ;
    lcd_cmd(1) ;
    delay_ms(4) ;
}

void lcd_out(unsigned char out,int flag){

    D7 = (out >> 7) & 1 ;
    D6 = (out >> 6) & 1 ;
    D5 = (out >> 5) & 1 ;
    D4 = (out >> 4) & 1 ;
    stbo(flag) ;
    D7 = (out >> 3) & 1 ;
    D6 = (out >> 2) & 1 ;
    D5 = (out >> 1) & 1 ;
    D4 = out  & 1 ;
    stbo(flag) ;
}
void lcd_data(int ten,int one,char asci){
    if(ten == 1){
        lcd_out(128 + one - 1,0) ;
        __delay_us(40) ;
        lcd_out(asci,1) ;

    } else if(ten == 2){
        lcd_out(128 + 0x40 + one - 1,0) ;
        __delay_us(40) ;
        lcd_out(asci,1) ;
    } else if(ten == 3){
        lcd_out(128 + 0x14 + one - 1,0) ;
        __delay_us(40) ;
        lcd_out(asci,1) ;
    } else {
        lcd_out(128 + 0x54 + one - 1,0) ;
        __delay_us(40) ;
        lcd_out(asci,1) ;
    }
   __delay_us(40) ;
}
void lcd_cmd(unsigned char cmd){

    D7 = (cmd >> 7) & 1 ;
    D6 = (cmd >> 6) & 1 ;
    D5 = (cmd >> 5) & 1 ;
    D4 = (cmd >> 4) & 1 ;
    stbo(0) ;
    D7 = (cmd >> 3) & 1 ;
    D6 = (cmd >> 2) & 1 ;
    D5 = (cmd >> 1) & 1 ;
    D4 = cmd  & 1 ;
    stbo(0) ;
    __delay_us(40) ;
}
void lcd_str(int ten, int one, char *str){
    if(ten == 1){
        lcd_out(128 + one - 1,0) ;
        __delay_us(90) ;

    } else if(ten == 2){
        lcd_out(128 + 0x40 + one - 1,0) ;
        __delay_us(90) ;

    } else if(ten == 3){
        lcd_out(128 + 0x14 + one - 1,0) ;
        __delay_us(90) ;
    } else {
        lcd_out(128 + 0x54 + one - 1,0) ;
        __delay_us(90) ;
    }
    while(*str != 0x00){		// NULL
		lcd_out(*str,1);
                __delay_us(160) ;
		str++;
	}
}
void send(unsigned char out) {

    D7 = (out >> 3) & 1 ;
    D6 = (out >> 2) & 1 ;
    D5 = (out >> 1) & 1 ;
    D4 = out  & 1 ;
    stbo(0) ;
}

