/*
 * File:   newmain.c
 * Author: M.Urushidani
 *
 * Created on 2019/04/15, 12:55
 */

#include <xc.h>
#include <stdlib.h>
#include        "LCDLib.h"
#include <stdio.h>


//  __CONFIG(FOSC_INTOSC & WDTE_OFF & PWRTE_ON & MCLRE_ON & CP_OFF
//		& CPD_OFF & BOREN_ON & CLKOUTEN_OFF & IESO_OFF & FCMEN_OFF);
//  __CONFIG(WRT_OFF & PLLEN_ON & STVREN_OFF & LVP_OFF);
#pragma config FOSC=INTOSCIO
#pragma config WDTE=OFF
#pragma config PWRTE=ON
#pragma config MCLRE=OFF
#pragma config CP=OFF
#pragma config CPD=OFF
#pragma config BOREN=OFF
#pragma config LVP=OFF 



//PIC16F819

void putch(char ch){
    lcd_out(ch, 1);
    return;
}

int adconv(unsigned char ch){
    unsigned int temp;
    //ADCON0 =(ch<<5) | 0b01000001;   //ch set and AD ON
    if (ch==0) ADCON0=0b01000001;
    else if (ch==1) ADCON0=0b01001001;
    else if (ch==2) ADCON0=0b01010001;
    else if (ch==3) ADCON0=0b01011001;
    else if (ch==4) ADCON0=0b01100001;
    __delay_us(20);
     GO_DONE = 1 ;             // ADϊJn
     while(GO_DONE) ;          // ϊI҂
     temp = ADRESH ;          // ADϊlADRESHADRESLɃZbg
     temp = ( temp << 8 ) | ADRESL ;  // 10rbg̕\
     return temp ;
}

  void main(){
    int i, adres, temp_out, temp_in, curr, set_temp;
    
    OSCCON = 0b01110100 ;     // NbN͂WlgƂ
    ADCON1 = 0b10000001;      // AN0-AN4AiOI/OɊ
    TRISA  = 0b00011111 ;     // 1œ 0ŏo AN0-AN4̂ݓ͂ɐݒ(RA5͓͐p)

    TRISB = 0 ;
    PORTB = 0 ;
    
    lcd_init() ;		//LCD
    lcd_cmd(1) ; 		//LCDNA
    while(1){
        lcd_cmd(1);
        delay_ms(2) ;
        lcd_str(1,1,"OUT   IN    CURR");
    
        adres=0;
        for (i=0; i<10; i++){
            adres=adres+adconv(0);
        }
        adres=adres/10;
        temp_out=(adres-300)*2;
        if(temp_out<0) temp_out=0;
        adres=0;
        for (i=0; i<10; i++){
            adres=adres+adconv(1);
        }
        adres=adres/10;
        temp_in=(adres-300)*2;
        if(temp_in<0) temp_in=0;
        adres=0;
        for (i=0; i<10; i++){
            adres=adres+adconv(2);
        }
        adres=adres/10;
        curr=adres;     //adconv(2);
        if(curr<0) curr=0;
        adres=0;
        for (i=0; i<10; i++){
            adres=adres+adconv(4);
        }
        adres=adres/10;
        set_temp=adres/5+200;
        if(set_temp<0) set_temp=0;
        if(set_temp<temp_in) RA7=1;
        else RA7=0;
        
        lcd_out(128+0x40,0);        //2s
        __delay_us(90);
        printf("%d.%d  %d.%d  %d.%dA", temp_out/10, temp_out%10, temp_in/10, temp_in%10, curr/100, (curr%100)/10);
        delay_ms(500);
    }
}

 