//pic12F675
#include <xc.h>

#define _XTAL_FREQ 4000000

#pragma config FOSC=INTRCIO, WDTE = OFF, MCLRE = OFF, CP = OFF

unsigned char dayFLAG;
int dayCNT;

void Wait(unsigned int num)
{
     unsigned int i ;

     for (i=0 ; i<num ; i++) {
         if(GP3==1){                //GP0, if day
             ++dayCNT;              //for solar chattering
             if (dayCNT>100) {
                 dayCNT=100;
                 dayFLAG=1;
             }
             else dayFLAG=0;
         }
         else {                     // night
             dayCNT=0;
             dayFLAG=0;
         }
         
         if((GP5==0) || (dayFLAG==0))    //(GP0==0)) if always or night
             if (GP1==0) GP2=1;     //if busy Audio ON
             else GP2=0;            //else  Audio OFF
         else GP2=0;
         __delay_ms(10) ;     // 10ms
     }
}

void Wait_sec(unsigned int num)
{
     unsigned int i ;

     for (i=0 ; i<num ; i++) {
          Wait(100) ;     // 1s
        //  if(GP3!=stateGP3) break;
        //  stateGP3=GP3;
     }
}

void main()
{
    unsigned char ad_data;
    unsigned int wait_cnt;
    
    OPTION_REG=0b11000000;         //OPTION

     TRISIO=0b00101011;
     
     CMCON=0x07;
     ANSEL=0b01010001;
     ADCON0=0b00000001;
   
     while(1) {
         //stateGP3=GP3;
         GPIObits.GP4 = 0;    //PLAY
         Wait(100) ;          // 1sec
         GPIObits.GP4 = 1; 
         ADCON0bits.GO_DONE=1;
         while(ADCON0bits.GO_DONE){}
         ad_data=ADRESH;
         if(ad_data<5) wait_cnt=60;         //1min
         else wait_cnt=(unsigned int)ad_data*14;
         Wait_sec(wait_cnt);      //1min
    }
}

